diff --git a/debian/control.d/migrate-oem-20.04 b/debian/control.d/migrate-oem-20.04
new file mode 100644
index 0000000..9a4a2f9
--- /dev/null
+++ b/debian/control.d/migrate-oem-20.04
@@ -0,0 +1,39 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-5.14/debian/control --output debian/control.d/transitionals-oem-20.04 oem-20.04$ generic-hwe-20.04
+#
+Package: linux-headers-oem-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-headers-generic-hwe-20.04
+Description: OEM Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-image-generic-hwe-20.04
+Description: OEM Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-tools-generic-hwe-20.04
+Description: OEM Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-generic-hwe-20.04
+Description: Complete OEM Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-modules-iwlwifi-generic-hwe-20.04
+Description: Extra drivers for iwlwifi for the oem flavour (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-20.04b b/debian/control.d/migrate-oem-20.04b
new file mode 100644
index 0000000..10f7adb
--- /dev/null
+++ b/debian/control.d/migrate-oem-20.04b
@@ -0,0 +1,32 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-5.14/debian/control --output debian/control.d/migrate-oem-20.04b oem-20.04b generic-hwe-20.04
+#
+Package: linux-headers-oem-20.04b
+Architecture: amd64
+Section: oldlibs
+Depends: linux-headers-generic-hwe-20.04
+Description: OEM Linux kernel headers (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-20.04b
+Architecture: amd64
+Section: oldlibs
+Depends: linux-image-generic-hwe-20.04
+Description: OEM Linux kernel image (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-20.04b
+Architecture: amd64
+Section: oldlibs
+Depends: linux-tools-generic-hwe-20.04
+Description: OEM Linux kernel tools (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-20.04b
+Architecture: amd64
+Section: oldlibs
+Depends: linux-generic-hwe-20.04
+Description: Complete OEM Linux kernel and headers (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-20.04c b/debian/control.d/migrate-oem-20.04c
new file mode 100644
index 0000000..535d90a
--- /dev/null
+++ b/debian/control.d/migrate-oem-20.04c
@@ -0,0 +1,32 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-5.14/debian/control --output debian/control.d/migrate-oem-20.04c oem-20.04c generic-hwe-20.04
+#
+Package: linux-headers-oem-20.04c
+Architecture: amd64
+Section: oldlibs
+Depends: linux-headers-generic-hwe-20.04
+Description: OEM Linux kernel headers (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-20.04c
+Architecture: amd64
+Section: oldlibs
+Depends: linux-image-generic-hwe-20.04
+Description: OEM Linux kernel image (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-20.04c
+Architecture: amd64
+Section: oldlibs
+Depends: linux-tools-generic-hwe-20.04
+Description: OEM Linux kernel tools (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-20.04c
+Architecture: amd64
+Section: oldlibs
+Depends: linux-generic-hwe-20.04
+Description: Complete OEM Linux kernel and headers (dummy transitional package) (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-20.04d b/debian/control.d/migrate-oem-20.04d
new file mode 100644
index 0000000..5041d01
--- /dev/null
+++ b/debian/control.d/migrate-oem-20.04d
@@ -0,0 +1,39 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-5.14/debian/control --output debian/control.d/migrate-oem-20.04d oem-20.04d generic-hwe-20.04
+#
+Package: linux-headers-oem-20.04d
+Architecture: amd64
+Section: oldlibs
+Depends: linux-headers-generic-hwe-20.04
+Description: OEM Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-20.04d
+Architecture: amd64
+Section: oldlibs
+Depends: linux-image-generic-hwe-20.04
+Description: OEM Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-20.04d
+Architecture: amd64
+Section: oldlibs
+Depends: linux-tools-generic-hwe-20.04
+Description: OEM Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-20.04d
+Architecture: amd64
+Section: oldlibs
+Depends: linux-generic-hwe-20.04
+Description: Complete OEM Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-20.04d
+Architecture: amd64
+Section: oldlibs
+Depends: linux-modules-iwlwifi-generic-hwe-20.04
+Description: Extra drivers for iwlwifi for the oem flavour (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+