diff --git a/debian/control.d/generic-lpae b/debian/control.d/generic-lpae
deleted file mode 100644
index 09ed0440704b..000000000000
--- a/debian/control.d/generic-lpae
+++ /dev/null
@@ -1,36 +0,0 @@
-Package: linux-headers-generic-lpae${variant:suffix}
-Architecture: armhf
-Section: kernel
-Depends: ${misc:Depends}, linux-headers-${kernel-abi-version}-generic-lpae
-Description: Generic LPAE Linux kernel headers
- This package will always depend on the latest generic-lpae kernel headers
- available.
-
-Package: linux-image-generic-lpae${variant:suffix}
-Architecture: armhf
-Section: kernel
-Provides: ${dkms:wireguard-linux-compat-modules}
-Depends: ${misc:Depends}, linux-image-${kernel-abi-version}-generic-lpae, linux-firmware
-Recommends: thermald [amd64]
-Description: Generic LPAE Linux kernel image
- This package will always depend on the latest generic-lpae kernel image
- available.
-
-Package: linux-tools-generic-lpae${variant:suffix}
-Architecture: armhf
-Section: kernel
-Provides: linux-tools
-Depends: ${misc:Depends}, linux-tools-${kernel-abi-version}-generic-lpae
-Description: Generic LPAE Linux kernel tools
- This package will always depend on the latest generic-lpae kernel tools
- available.
-
-Package: linux-generic-lpae${variant:suffix}
-Architecture: armhf
-Section: kernel
-Provides: ${test:provides-full-generic-lpae}
-Depends: ${misc:Depends}, linux-image-generic-lpae${variant:suffix} (= ${binary:Version}), linux-headers-generic-lpae${variant:suffix} (= ${binary:Version})
-Description: Complete Generic LPAE Linux kernel and headers
- This package will always depend on the latest complete generic-lpae Linux kernel
- and headers.
-
diff --git a/debian/control.d/transitionals-generic-lpae b/debian/control.d/transitionals-generic-lpae
new file mode 100644
index 000000000000..883dc603ed9e
--- /dev/null
+++ b/debian/control.d/transitionals-generic-lpae
@@ -0,0 +1,32 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input debian/control --output debian/control.d/transitionals-generic-lpae generic-lpae generic
+#
+Package: linux-headers-generic-lpae
+Architecture: armhf
+Section: oldlibs
+Depends: linux-headers-generic
+Description: Generic LPAE Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-lpae
+Architecture: armhf
+Section: oldlibs
+Depends: linux-image-generic
+Description: Generic LPAE Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-lpae
+Architecture: armhf
+Section: oldlibs
+Depends: linux-tools-generic
+Description: Generic LPAE Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-lpae
+Architecture: armhf
+Section: oldlibs
+Depends: linux-generic-wip
+Description: Complete Generic LPAE Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/virtual b/debian/control.d/virtual
index ccfdb91d415f..fdfc8e63bd2b 100644
--- a/debian/control.d/virtual
+++ b/debian/control.d/virtual
@@ -1,14 +1,14 @@
 Package: linux-headers-virtual${variant:suffix}
 Architecture: amd64 arm64 armhf ppc64el s390x
 Section: kernel
-Depends: ${misc:Depends}, linux-headers-generic${variant:suffix} (= ${binary:Version}) [amd64 arm64 ppc64el s390x], linux-headers-generic-lpae${variant:suffix} (= ${binary:Version}) [armhf]
+Depends: ${misc:Depends}, linux-headers-generic${variant:suffix} (= ${binary:Version})
 Description: Virtual Linux kernel headers
  This package will always depend on linux-headers-generic.
 
 Package: linux-image-virtual${variant:suffix}
 Architecture: amd64 arm64 armhf ppc64el s390x
 Section: kernel
-Depends: ${misc:Depends}, linux-image-${kernel-abi-version}-generic [amd64 arm64 ppc64el s390x], linux-image-${kernel-abi-version}-generic-lpae [armhf]
+Depends: ${misc:Depends}, linux-image-${kernel-abi-version}-generic
 Provides: ${dkms:zfs-modules} ${dkms:virtualbox-guest-modules} ${dkms:wireguard-linux-compat-modules}
 Description: Virtual Linux kernel image
  This package will always depend on the latest minimal generic kernel image
@@ -18,7 +18,7 @@ Package: linux-tools-virtual${variant:suffix}
 Architecture: amd64 arm64 armhf ppc64el s390x
 Section: kernel
 Provides: linux-tools
-Depends: ${misc:Depends}, linux-tools-${kernel-abi-version}-generic [amd64 arm64 ppc64el s390x], linux-tools-${kernel-abi-version}-generic-lpae [armhf]
+Depends: ${misc:Depends}, linux-tools-${kernel-abi-version}-generic
 Description: Virtual Linux kernel tools
  This package will always depend on the latest minimal generic kernel tools
  used for virtual instances.