diff --git a/debian/control.d/migrate-oem-22.04 b/debian/control.d/migrate-oem-22.04
new file mode 100644
index 0000000..0164276
--- /dev/null
+++ b/debian/control.d/migrate-oem-22.04
@@ -0,0 +1,76 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-6.5/debian/control --output debian/control.d/migrate-oem-22.04 oem-22.04 -generic${variant:suffix}
+#
+Package: linux-headers-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-headers-generic${variant:suffix}
+Description: OEM Linux kernel headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: OEM Linux kernel image (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-uc-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-uc-generic${variant:suffix}
+Description: Oem Linux kernel image for Ubuntu Core (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-tools-generic${variant:suffix}
+Description: OEM Linux kernel tools (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-generic${variant:suffix}
+Description: Complete OEM Linux kernel and headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ipu6-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-ipu6-generic${variant:suffix}
+Description: Extra drivers for ipu6 for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ivsc-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: Extra drivers for ivsc for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-iwlwifi-generic${variant:suffix}
+Description: Extra drivers for iwlwifi for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-usbio-oem-22.04
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-usbio-generic${variant:suffix}
+Description: Extra drivers for usbio for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-22.04a b/debian/control.d/migrate-oem-22.04a
new file mode 100644
index 0000000..2e5a361
--- /dev/null
+++ b/debian/control.d/migrate-oem-22.04a
@@ -0,0 +1,60 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-5.17/debian/control --output debian/control.d/migrate-oem-22.04a oem-22.04a -generic${variant:suffix}
+#
+Package: linux-headers-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-headers-generic${variant:suffix}
+Description: OEM Linux kernel headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: OEM Linux kernel image (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-tools-generic${variant:suffix}
+Description: OEM Linux kernel tools (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-generic${variant:suffix}
+Description: Complete OEM Linux kernel and headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ipu6-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-ipu6-generic${variant:suffix}
+Description: Extra drivers for ipu6 for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ivsc-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: Extra drivers for ivsc for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-22.04a
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-iwlwifi-generic${variant:suffix}
+Description: Extra drivers for iwlwifi for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-22.04b b/debian/control.d/migrate-oem-22.04b
new file mode 100644
index 0000000..bae90b2
--- /dev/null
+++ b/debian/control.d/migrate-oem-22.04b
@@ -0,0 +1,60 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-6.0/debian/control --output debian/control.d/migrate-oem-22.04b oem-22.04b -generic${variant:suffix}
+#
+Package: linux-headers-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-headers-generic${variant:suffix}
+Description: OEM Linux kernel headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: OEM Linux kernel image (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-tools-generic${variant:suffix}
+Description: OEM Linux kernel tools (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-generic${variant:suffix}
+Description: Complete OEM Linux kernel and headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ipu6-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-ipu6-generic${variant:suffix}
+Description: Extra drivers for ipu6 for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ivsc-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: Extra drivers for ivsc for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-22.04b
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-iwlwifi-generic${variant:suffix}
+Description: Extra drivers for iwlwifi for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-22.04c b/debian/control.d/migrate-oem-22.04c
new file mode 100644
index 0000000..4828962
--- /dev/null
+++ b/debian/control.d/migrate-oem-22.04c
@@ -0,0 +1,60 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-6.1/debian/control --output debian/control.d/migrate-oem-22.04c oem-22.04c -generic${variant:suffix}
+#
+Package: linux-headers-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-headers-generic${variant:suffix}
+Description: OEM Linux kernel headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: OEM Linux kernel image (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-tools-generic${variant:suffix}
+Description: OEM Linux kernel tools (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-generic${variant:suffix}
+Description: Complete OEM Linux kernel and headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ipu6-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-ipu6-generic${variant:suffix}
+Description: Extra drivers for ipu6 for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ivsc-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: Extra drivers for ivsc for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-22.04c
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-iwlwifi-generic${variant:suffix}
+Description: Extra drivers for iwlwifi for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
diff --git a/debian/control.d/migrate-oem-22.04d b/debian/control.d/migrate-oem-22.04d
new file mode 100644
index 0000000..aa946ac
--- /dev/null
+++ b/debian/control.d/migrate-oem-22.04d
@@ -0,0 +1,76 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input ../linux-meta-oem-6.5/debian/control --output debian/control.d/migrate-oem-22.04d oem-22.04d -generic${variant:suffix}
+#
+Package: linux-headers-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-headers-generic${variant:suffix}
+Description: OEM Linux kernel headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: OEM Linux kernel image (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-uc-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-uc-generic${variant:suffix}
+Description: Oem Linux kernel image for Ubuntu Core (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-tools-generic${variant:suffix}
+Description: OEM Linux kernel tools (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-generic${variant:suffix}
+Description: Complete OEM Linux kernel and headers (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ipu6-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-ipu6-generic${variant:suffix}
+Description: Extra drivers for ipu6 for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-ivsc-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-image-generic${variant:suffix}
+Description: Extra drivers for ivsc for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-iwlwifi-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-iwlwifi-generic${variant:suffix}
+Description: Extra drivers for iwlwifi for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-modules-usbio-oem-22.04d
+Architecture: amd64
+Section: oldlibs
+Multi-Arch: no
+Depends: linux-modules-usbio-generic${variant:suffix}
+Description: Extra drivers for usbio for the oem flavour (transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+